#INCLUDE "PROTHEUS.CH"
#INCLUDE "TOTVS.CH"
#INCLUDE "FWMVCDEF.CH"
/*/


Ŀ
Funao     VOKA0905  | Autor  Marcelo Brigagao               Data 01/09/2010
Ĵ
Descriao  Altera comissao de pedidos ja faturados                             
Ĵ
Uso        Especifico                                                          
ٱ


Obs.: A funcao/rotina VK0905Vld tambem eh chamada atraves do PE MA410MNU.

Esta rotina permite:
- Alteracao de vendedores e % comissao dos pedidos;
- Visualizacao de pedidos;
- Visualizacao de orcamentos;

Implementacoes / Alteracoes
Marcelo Brigagao : 28/09/10
- Criada rotina para alteracao das comissoes por lote (codigo do negocio (C5_CODNEG));
  
Marcelo Brigagao : 06/10/10
- Alterado para validar quais usuarios tem acesso a alteracao de comissao; 

Marcelo Brigagao: 26/04/11
- Alterado validacao dos usuarios para acesso a alteracao de comissao;

Marcelo Brigagao: 17/05/11
- Alterada validacao do usuarios para acesso a alteracao de comissao, permitindo apenas os Grupos Administradores 
  e Diretoria;

Marcelo Brigagao: 15/05/12
- Ajustado para mostrar no browse tambem os vendedores 6,7 e 8. 

Marcelo Brigagao: 08/10/12
- Alterada a forma de validar o grupo do usuario, verificando se o retorno da funcao UsrRetGrp() e valido;

Marcelo Brigagao: 11/04/13
- Rotina reescrita utilizando a classe FWMBrowse e FWMarkBrowse, fonte antigo para referencia VOKA0905_OLD.PRW;
- Ajustes gerais para ganho de performance;

Marcelo Brigagao: 22/05/2013
- Alterada validacao do usuarios para acesso a alteracao de comissao, permitindo tambem Crsitiane Boldorini;

/*/
User Function VOKA0905()

Private cAlias   := "SC5"
Private nRecno   := 0
Private aRotina  := {}
Private aCampos	 := {}
Private aComisOri:= {}
Private aComisNew:= {} 
Private cNomeUser:= Alltrim(UsrRetName(__CUSERID))
Private aGrpUser := UsrRetGrp()
Private cGrpUser := "ZZZZZZ"  
Private cCodNeg  := ""
Private oBrowse

If Len(aGrpUser) > 0
   cGrpUser := aGrpUser[1]
EndIf   

aRotina :={	{"Pesquisar"		  ,"AxPesqui",0,1},;
			{"Visualiza pedido "  ,"a410Visual(cAlias,Recno(),2)",0,2},;
			{"visualiza Oramento","U_VK0905Visu(SubStr(C5_NROCP,1,6))",0,2}}

If cGrpUser ="000000" .or. cGrpUser = "000015" .or. cNomeUser = "Cristiane"
	aAdd(aRotina,{"Altera Comissao"	   ,"U_VK0905Vld(cAlias,Recno())",0,4})     // tambem chamada atraves do PE MA410MNU
	aAdd(aRotina,{"aLt.comissao p/lote","U_VK0905Alt(cAlias,Recno(),.T.)",0,4})
EndIf

aCampos := {}
aAdd(aCampos,{"Nr.Pedido"	,"C5_NUM"	 })
aAdd(aCampos,{"Cod.Cliente"	,"C5_CLIENTE"})
aAdd(aCampos,{"Loja"		,"C5_LOJACLI"})
aAdd(aCampos,{"Dt.Emisso"	,"C5_EMISSAO"}) 
aAdd(aCampos,{"Tp Orc/Ped"	,"C5_TIPOORC"})
aAdd(aCampos,{"Vendedor 1"	,"C5_VEND1"	 })
aAdd(aCampos,{"Comissao 1"	,"C5_COMIS1" })
aAdd(aCampos,{"Vendedor 2"	,"C5_VEND2"	 })
aAdd(aCampos,{"Comissao 2"	,"C5_COMIS2" })
aAdd(aCampos,{"Vendedor 3"	,"C5_VEND3"	 })
aAdd(aCampos,{"Comissao 3"	,"C5_COMIS3" })
aAdd(aCampos,{"Vendedor 4"	,"C5_VEND4"	 })
aAdd(aCampos,{"Comissao 4"	,"C5_COMIS4" })
aAdd(aCampos,{"Vendedor 5"	,"C5_VEND5"	 })
aAdd(aCampos,{"Comissao 5"	,"C5_COMIS5" })
aAdd(aCampos,{"Vendedor 6"	,"C5_VEND6"	 })
aAdd(aCampos,{"Comissao 6"	,"C5_COMIS6" })
aAdd(aCampos,{"Vendedor 7"	,"C5_VEND7"	 })
aAdd(aCampos,{"Comissao 7"	,"C5_COMIS7" })
aAdd(aCampos,{"Vendedor 8"	,"C5_VEND8"	 })
aAdd(aCampos,{"Comissao 8"	,"C5_COMIS8" })

dbSelectArea("SC5") 
dbSetOrder(1)

//Ŀ
// Construcao do Browse                                 
//
oBrowse:=FWMBrowse():New() // Cria o objeto oBrowse
oBrowse:SetAlias("SC5")    // Define a tabela do Browse
oBrowse:SetDescription("Alterao de Comisso / Vendedores")  // Define o titulo do Browse
oBrowse:SetFields(aCampos) // Define os campos a serem mostrados no Browse

oBrowse:AddLegend("Empty(C5_LIBEROK).And.Empty(C5_NOTA) .And. Empty(C5_BLQ)","GREEN","Pedido de Venda em Aberto")// Define a legenda do Browse
oBrowse:AddLegend("!Empty(C5_LIBEROK).And.Empty(C5_NOTA).And. Empty(C5_BLQ)","YELLOW","Pedido de Venda Liberado")
oBrowse:AddLegend("!Empty(C5_NOTA).Or.C5_LIBEROK=='E' .And. Empty(C5_BLQ)","RED"     ,"Pedido de Venda Encerrado") 
oBrowse:AddLegend("C5_BLQ == '2'","ORANGE","Pedido de Venda com Bloqueio de Verba")
oBrowse:AddLegend("C5_BLQ == '1'","BLUE","Pedido de Venda com Bloqueio de Regra") 
//oBrowse:DisableDetails()         // Desabilita a exibicao dos detalhes do Browse
//oBrowse:DisableReport()          // Desabilita a opcao de imprimir 
//oBrowse:DisableConfig()         // Desabilita a opcao de configurar o Browse
oBrowse:Activate() // Ativacao do Browse

dbSelectArea("SC5") 
RetIndex("SC5")
dbClearFilter()

Return()

/*/


Ŀ
Programa  VK0905Visu Autor    Marcelo Brigagao     Data  22/09/10 
Ĵ
Descrio  Visualiza Orcamento de Vendas                              
ٱ


/*/
User Function VK0905Visu( cNrOrc )
Local cArea := GetArea()

dbSelectArea("SCJ")
dbSetOrder(1)
If dbSeek(xFilial("SCJ")+ cNrOrc)
	a415Visual("SCJ",Recno(),2)  // Funcao padrao Protheus
Else
	MsgInfo("No existe oramento para este pedido.","Ateno")
EndIf

RestArea(cArea)
Return()

/*/


Ŀ
Programa  VK0905Vld  Autor    Marcelo Brigagao     Data  01/09/10 
Ĵ
Descrio  Valida se a comissao pode ser alterada                     
ٱ


/*/
User Function VK0905Vld(cAlias,nRecno)
Local lRet  := .T.
Local cArea := GetArea()

dbSelectArea("SE1")
dbOrderNickName("PEDIDO")
If dbSeek(xFilial("SE1")+SC5->C5_NUM,.F.)
	If !Empty(SE1->E1_BAIXA) .or. SE1->E1_SALDO > 0
		dbSelectArea("SE3")
		dbSetOrder(1)
		If dbSeek(xFilial("SE3")+SE1->E1_PREFIXO+SE1->E1_NUM+SE1->E1_PARCELA,.F.)
			If !Empty(SE3->E3_DATA)
				If Alltrim(Subs(cUsuario,7,15)) == "Marcelo" .Or. Alltrim(Subs(cUsuario,7,15)) == "Administrador"
					MsgStop("Pedido com comisso paga em "+ dToc(SE3->E3_DATA)+" ","Erro")
					lRet := .T.
				Else
					lRet := .F.
				EndIF
			EndIf
		EndIf
	EndIf
EndIf

RestArea(cArea)

If lRet
	U_VK0905Alt(cAlias,nRecno,.F.)
Else
	MsgStop("Pedido com comisso paga em "+ dToc(SE3->E3_DATA)+" ","Erro")
EndIf

Return()

/*/


Ŀ
Programa  VK0905Alt  Autor    Marcelo Brigagao     Data  01/09/10 
Ĵ
Descrio  Pega os novos dados                                        
ٱ


/*/
User Function VK0905Alt(cAlias,nRecno,lLote)
Local oGroup1
Local oGroup2
Local _lOk	:= .F.
Local cDadosPed := ""
Local cOrcament := "Orcamento : "+ SubStr(SC5->C5_NROCP,1,6)    
Local cArea     := GetArea()
Local _cVend1   := SC5->C5_VEND1
Local _cVend2	:= SC5->C5_VEND2
Local _cVend3	:= SC5->C5_VEND3
Local _cVend4	:= SC5->C5_VEND4
Local _cVend5	:= SC5->C5_VEND5
Local _nComis1	:= SC5->C5_COMIS1
Local _nComis2	:= SC5->C5_COMIS2
Local _nComis3	:= SC5->C5_COMIS3
Local _nComis4	:= SC5->C5_COMIS4
Local _nComis5  := SC5->C5_COMIS5

cCodNeg := SC5->C5_CODNEG

aComisOri:={{SC5->C5_VEND1,SC5->C5_COMIS1},;
			{SC5->C5_VEND2,SC5->C5_COMIS2},;
			{SC5->C5_VEND3,SC5->C5_COMIS3},;
			{SC5->C5_VEND4,SC5->C5_COMIS4},;
			{SC5->C5_VEND5,SC5->C5_COMIS5}}
If !lLote
	cDadosPed := "Ped.: " +SC5->C5_NUM+ " - Cliente: " +SC5->C5_CLIENTE+ "/" +SC5->C5_LOJACLI+ " - "
Else
	cDadosPed := "Neg.: " +SC5->C5_CODNEG+ " - Cliente: " +SC5->C5_CLIENTE+ "/" +SC5->C5_LOJACLI+ " - "	
EndIf	
cDadosPed += Alltrim(Posicione("SA1",1,xFilial("SA1")+SC5->C5_CLIENTE+SC5->C5_LOJACLI,"A1_NOME"))
	
DEFINE MSDIALOG oDlg TITLE OemToAnsi("Alterao Vendedor / Comisso") FROM 000,000 TO 350,500 PIXEL
DEFINE SBUTTON oBtn FROM 800,800 TYPE 5 ENABLE OF oDlg

@ 018,010 SAY OemToAnsi(cDadosPed) SIZE 205,010 OF oDlg COLORS 255, 16777215 PIXEL
@ 030,010 SAY OemtoAnsi(cOrcament) SIZE 205,010 OF oDlg COLORS 255, 16777215 PIXEL

@ 040,010 GROUP oGroup1 TO 095,245 PROMPT OemToAnsi("Dados Atuais ") OF oDlg COLOR 0, 16777215 PIXEL
@ 055,015 SAY OemToAnsi("Vendedor 1") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 070,015 SAY aComisOri[1,1] SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 085,015 SAY aComisOri[1,2] Picture PesqPict("SC5","C5_COMIS1") SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL

@ 055,060 SAY OemToAnsi("Vendedor 2") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 070,060 SAY aComisOri[2,1] SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 085,060 SAY aComisOri[2,2] Picture PesqPict("SC5","C5_COMIS1") SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL

@ 055,110 SAY OemToAnsi("Vendedor 3") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 070,110 SAY aComisOri[3,1] SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 085,110 SAY aComisOri[3,2] Picture PesqPict("SC5","C5_COMIS1") SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL

@ 055,160 SAY OemToAnsi("Vendedor 4") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 070,160 SAY aComisOri[4,1] SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 085,160 SAY aComisOri[4,2] Picture PesqPict("SC5","C5_COMIS1") SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL

@ 055,210 SAY OemToAnsi("Vendedor 5") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 070,210 SAY aComisOri[5,1] SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 085,210 SAY aComisOri[5,2] Picture PesqPict("SC5","C5_COMIS1") SIZE 025,009 OF oDlg COLORS 0, 16777215 PIXEL

@ 100,010 GROUP oGroup2 TO 165,245 PROMPT OemToAnsi("Dados Novos ") OF oDlg COLOR 0, 16777215 PIXEL
@ 115,015 SAY OemToAnsi("Vendedor 1") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 130,015 MSGET _cVend1 F3 "SA3" Picture PesqPict("SC5","C5_VEND1") Valid Vazio(_cVend1) .or. ExistCpo("SA3",_cVend1) SIZE 30,09 OF oDlg PIXEL
@ 145,015 MSGET _nComis1 Picture PesqPict("SC5","C5_COMIS1") SIZE 15,09 OF oDlg PIXEL

@ 115,060 SAY OemToAnsi("Vendedor 2") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 130,060 MSGET _cVend2 F3 "SA3" Picture PesqPict("SC5","C5_VEND1") Valid Vazio(_cVend2) .or. ExistCpo("SA3",_cVend2) SIZE 30,09 OF oDlg PIXEL
@ 145,060 MSGET _nComis2 Picture PesqPict("SC5","C5_COMIS1") SIZE 15,09 OF oDlg PIXEL

@ 115,110 SAY OemToAnsi("Vendedor 3") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 130,110 MSGET _cVend3 F3 "SA3" Picture PesqPict("SC5","C5_VEND1") Valid Vazio(_cVend3) .or. ExistCpo("SA3",_cVend3) SIZE 30,09 OF oDlg PIXEL
@ 145,110 MSGET _nComis3 Picture PesqPict("SC5","C5_COMIS1") SIZE 15,09 OF oDlg PIXEL

@ 115,160 SAY OemToAnsi("Vendedor 4") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 130,160 MSGET _cVend4 F3 "SA3" Picture PesqPict("SC5","C5_VEND1") Valid Vazio(_cVend4) .or. ExistCpo("SA3",_cVend4) SIZE 30,09 OF oDlg PIXEL
@ 145,160 MSGET _nComis4 Picture PesqPict("SC5","C5_COMIS1") SIZE 15,09 OF oDlg PIXEL

@ 115,210 SAY OemToAnsi("Vendedor 5") SIZE 029,009 OF oDlg COLORS 0, 16777215 PIXEL
@ 130,210 MSGET _cVend5 F3 "SA3" Picture PesqPict("SC5","C5_VEND1") Valid Vazio(_cVend5) .or. ExistCpo("SA3",_cVend5) SIZE 30,09 OF oDlg PIXEL
@ 145,210 MSGET _nComis5 Picture PesqPict("SC5","C5_COMIS1") SIZE 15,09 OF oDlg PIXEL

ACTIVATE MSDIALOG oDlg CENTER ON INIT EnchoiceBar(oDlg,{||(_lOk:=.T.,oDlg:End())},{||(_lOk:=.F.,oDlg:End())})

// Processa substituicao das comissoes
If _lOk
	aComisNew:={{_cVend1,_nComis1},;
				{_cVend2,_nComis2},;
				{_cVend3,_nComis3},;
				{_cVend4,_nComis4},;
				{_cVend5,_nComis5}}
    If !lLote
		Processa({|| VK0905Grv(cAlias,nRecno,aComisOri,aComisNew)},"Aguarde","Efetivando alteraes...")        
	Else
		Processa({|| VK0905Sel(cAlias,nRecno,cCodNeg,aComisOri,aComisNew)},"Aguarde","Aplicando filtro para seleo p/ lote...")
	EndIf		
EndIf

RestArea(cArea)

Return()

/*/


Ŀ
Programa  VK0905Grv  Autor    Marcelo Brigagao     Data  01/09/10 
Ĵ
Descrio  Grava alteracao das comissoes                              
ٱ


/*/
Static Function VK0905Grv(cAlias,nRecno,aComisOri,aComisNew)

If !ArrayCompare(aComisOri,aComisNew)
	
	dbSelectArea(cAlias)
	dbGoTo(nRecno)
	Reclock(cAlias,.F.)
	SC5->C5_VEND1 := aComisNew[1,1]
	SC5->C5_COMIS1:= aComisNew[1,2]
	
	SC5->C5_VEND2 := aComisNew[2,1]
	SC5->C5_COMIS2:= aComisNew[2,2]
	
	SC5->C5_VEND3 := aComisNew[3,1]
	SC5->C5_COMIS3:= aComisNew[3,2]
	
	SC5->C5_VEND4 := aComisNew[4,1]
	SC5->C5_COMIS4:= aComisNew[4,2]
	
	SC5->C5_VEND5 := aComisNew[5,1]
	SC5->C5_COMIS5:= aComisNew[5,2]
	
	SC5->C5_TPCLC := "C"
	MsUnlock()
	
	dbSelectArea("SD2")
	dbSetOrder(8)
	If dbSeek(xFilial("SD2")+SC5->C5_NUM,.F.)
		
		While !EOF() .and. SD2->D2_PEDIDO == SC5->C5_NUM
			RecLock("SD2",.F.)
			SD2->D2_COMIS1 := aComisNew[1,2]
			SD2->D2_COMIS2 := aComisNew[2,2]
			SD2->D2_COMIS3 := aComisNew[3,2]
			SD2->D2_COMIS4 := aComisNew[4,2]
			SD2->D2_COMIS5 := aComisNew[5,2]
			MsUnlock()
			
			dbSelectArea("SF2")
			dbSetOrder(1)
			
			If dbSeek(xFilial("SF2")+SD2->D2_DOC+SD2->D2_SERIE,.F.)
				Reclock("SF2",.F.)
				SF2->F2_VEND1 := aComisNew[1,1]
				SF2->F2_VEND2 := aComisNew[2,1]
				SF2->F2_VEND3 := aComisNew[3,1]
				SF2->F2_VEND4 := aComisNew[4,1]
				SF2->F2_VEND5 := aComisNew[5,1]
				MsUnlock()
			EndIf
			
			dbSelectArea("SE1")
			dbSetOrder(1)
			
			If dbSeek(xFilial("SE1")+SD2->D2_SERIE+SD2->D2_DOC,.F.)
				While !EOF() .and. SE1->E1_PREFIXO+SE1->E1_NUM == SD2->D2_SERIE+SD2->D2_DOC
					Reclock("SE1",.F.)
					SE1->E1_VEND1 := aComisNew[1,1]
					SE1->E1_VEND2 := aComisNew[2,1]
					SE1->E1_VEND3 := aComisNew[3,1]
					SE1->E1_VEND4 := aComisNew[4,1]
					SE1->E1_VEND5 := aComisNew[5,1]
					
					SE1->E1_COMIS1 := aComisNew[1,2]
					SE1->E1_COMIS2 := aComisNew[2,2]
					SE1->E1_COMIS3 := aComisNew[3,2]
					SE1->E1_COMIS4 := aComisNew[4,2]
					SE1->E1_COMIS5 := aComisNew[5,2]
					MsUnlock()
					
					dbSelectArea("SE1")
					dbSkip()
				EndDo
			EndIf
			dbSelectArea("SD2")
			dbSkip()
		EndDo
	EndIf
EndIf

dbSelectArea(cAlias)
dbGoTo(nRecno)

Return()

/*/


Ŀ
Programa  VK0905Sel  Autor    Marcelo Brigagao     Data  22/09/10 
Ĵ
Descrio  Seleciona os pedidos a serem alterados                     
ٱ


/*/
Static Function VK0905Sel(cAlias,nRecno,cCodNeg,aComisOri,aComisNew)
Local cQryTRB     := ""
Local aCpos		  := {}
Local aBackRotina := Aclone(aRotina)
Local cTitBrow    := OemToAnsi("Alterao de Comisso")
Local _cArq       := "T_"+Criatrab(,.F.)

Private cAliasTRB := GetNextAlias()
Private cAliasTMP := GetNextAlias()
Private aRotina   := {{"Processa","U_VK0905GL", 0,4}}
Private oMark

dbSelectArea("SC5")
dbSetOrder(1)

cQryTRB := "SELECT SC5.*,SC5.R_E_C_N_O_ AS C5RECNO FROM "
cQryTRB += RetSqlName("SC5") + " SC5 WHERE "
cQryTRB += "SC5.D_E_L_E_T_ = ' ' AND "
cQryTRB += "SC5.C5_FILIAL='"+xFilial("SC5")+"' And  SC5.C5_CODNEG='"+cCodNeg+"'"
cQryTRB += " ORDER BY "+SqlOrder(SC5->(IndexKey()))
cQryTRB := ChangeQuery(cQryTRB) 

dbUseArea( .T.,"TOPCONN", TcGenQry( ,,cQryTRB ), cAliasTMP, .T., .F. )
TcSetField(cAliasTMP,"C5_EMISSAO","D",8,0)

dbSelectArea(cAliasTMP)
copy to &_carq
dbUseArea( .T.,__LOCALDRIVER, _cArq,cAliasTRB, .T. , .F. )
dbSelectArea(cALiasTRB)
dbGoTop()

aCpos := {}
aAdd(aCpos,{"C5_CODNEG"		,,"Cod.Negocio"	,PesqPict("SC5","C5_CODNEG")})
aAdd(aCpos,{"C5_NUM"		,,"Nr.Pedido"	,PesqPict("SC5","C5_NUM")})
aAdd(aCpos,{"C5_CLIENTE"	,,"Cod.Cliente"	,PesqPict("SC5","C5_CLIENTE")})
aAdd(aCpos,{"C5_LOJACLI"	,,"Loja"		,PesqPict("SC5","C5_LOJACLI")})
aAdd(aCpos,{"C5_EMISSAO"	,,"Dt.Emisso"	,PesqPict("SC5","C5_EMISSAO")})
aAdd(aCpos,{"C5_VEND1"		,,"Vendedor 1"	,PesqPict("SC5","C5_VEND1")})
aAdd(aCpos,{"C5_COMIS1"		,,"Comissao 1"	,PesqPict("SC5","C5_COMIS1")})
aAdd(aCpos,{"C5_VEND2"		,,"Vendedor 2"	,PesqPict("SC5","C5_VEND2")})
aAdd(aCpos,{"C5_COMIS2"		,,"Comissao 2"	,PesqPict("SC5","C5_COMIS2")})
aAdd(aCpos,{"C5_VEND3"		,,"Vendedor 3"	,PesqPict("SC5","C5_VEND3")})
aAdd(aCpos,{"C5_COMIS3"		,,"Comissao 3"	,PesqPict("SC5","C5_COMIS3")})
aAdd(aCpos,{"C5_VEND4"		,,"Vendedor 4"	,PesqPict("SC5","C5_VEND4")})
aAdd(aCpos,{"C5_COMIS4"		,,"Comissao 4"	,PesqPict("SC5","C5_COMIS4")})
aAdd(aCpos,{"C5_VEND5"		,,"Vendedor 5"	,PesqPict("SC5","C5_VEND5")})
aAdd(aCpos,{"C5_COMIS5"		,,"Comissao 5"	,PesqPict("SC5","C5_COMIS5")})

//Ŀ
// Construcao do MarkBrowse                             
//
oMark:= FWMarkBrowse():NEW()   // Cria o objeto oMark - MarkBrowse
oMark:SetAlias(cAliasTRB)      // Define a tabela do MarkBrowse
oMark:SetDescription(cTitBrow) // Define o titulo do MarkBrowse
oMark:SetFieldMark("C5_OK")    // Define o campo utilizado para a marcacao
oMark:SetFilterDefault()       // Define o filtro a ser aplicado no MarkBrowse
oMark:SetFields(aCpos)         // Define os campos a serem mostrados no MarkBrowse
oMark:SetSemaphore(.F.)        // Define se utiliza marcacao exclusiva 
//oMark:DisableDetails()         // Desabilita a exibicao dos detalhes do MarkBrowse
//oMark:DisableConfig()          // Desabilita a opcao de configuracao do MarkBrowse
//oMark:DisableReport()          // Desabilita a opcao de imprimir 
oMark:Activate()               // Ativa o MarkBrowse

//Ŀ
//Restaura condicao original                                              
//
dbSelectArea(cAliasTRB)
dbCloseArea(cAliasTRB)
dbSelectArea(cAliasTMP)
dbCloseArea(cAliasTMP)
fErase(_cArq+".DBF") 

dbSelectArea("SC5")
RetIndex("SC5")
dbClearFilter()

aRotina:=ACLONE(aBackRotina)

Return()

/*/


Ŀ
Programa  VK0905GL   Autor    Marcelo Brigagao     Data  17/08/10 
Ĵ
Descrio  Efetiva as alteracoes.                                     
ٱ


/*/
User Function VK0905GL(cAlias,nRecno,nOpc,cMarca,lInverte)

Processa({|| DoLtGrv(aComisOri,aComisNew)},"Aguarde","Efetivando alteraes...")

Return()

/*/


Ŀ
Programa   DoLtGrv   Autor    Marcelo Brigagao     Data  17/08/10 
Ĵ
Descrio  Efetiva as alteracoes.                                     
ٱ


/*/
Static Function DoLtGrv(aComisOri,aComisNew)
Local aRecnosSC5 := {}
Local cMarca := oMark:Mark()
Local nz := 0

dbSelectArea(cAliasTRB)
dbGoTop()
While !Eof()
	If oMark:IsMark(cMarca)
		aAdd(aRecnosSC5,{(cAliasTRB)->C5RECNO,(cAliasTRB)->C5_NUM} )
	EndIf
	dbSkip()
EndDo

dbSelectArea("SC5")

ProcRegua(Len(aRecnosSC5))

For nz:= 1 to Len(aRecnosSC5)
	dbSelectArea(cAlias)
	dbGoTo(aRecnosSC5[nz,1])
	
	Reclock(cAlias,.F.)
	SC5->C5_VEND1 := aComisNew[1,1]
	SC5->C5_COMIS1:= aComisNew[1,2]
	
	SC5->C5_VEND2 := aComisNew[2,1]
	SC5->C5_COMIS2:= aComisNew[2,2]
	
	SC5->C5_VEND3 := aComisNew[3,1]
	SC5->C5_COMIS3:= aComisNew[3,2]
	
	SC5->C5_VEND4 := aComisNew[4,1]
	SC5->C5_COMIS4:= aComisNew[4,2]
	
	SC5->C5_VEND5 := aComisNew[5,1]
	SC5->C5_COMIS5:= aComisNew[5,2]
	
	SC5->C5_TPCLC := "C"
	MsUnlock()
	
	dbSelectArea("SD2")
	dbSetOrder(8)
	If dbSeek(xFilial("SD2")+aRecnosSC5[nz,2],.F.)
		
		While !EOF() .and. SD2->D2_PEDIDO == aRecnosSC5[nz,2]
			RecLock("SD2",.F.)
			SD2->D2_COMIS1 := aComisNew[1,2]
			SD2->D2_COMIS2 := aComisNew[2,2]
			SD2->D2_COMIS3 := aComisNew[3,2]
			SD2->D2_COMIS4 := aComisNew[4,2]
			SD2->D2_COMIS5 := aComisNew[5,2]
			MsUnlock()
			
			dbSelectArea("SF2")
			dbSetOrder(1)
			If dbSeek(xFilial("SF2")+SD2->D2_DOC+SD2->D2_SERIE,.F.)
				Reclock("SF2",.F.)
				SF2->F2_VEND1 := aComisNew[1,1]
				SF2->F2_VEND2 := aComisNew[2,1]
				SF2->F2_VEND3 := aComisNew[3,1]
				SF2->F2_VEND4 := aComisNew[4,1]
				SF2->F2_VEND5 := aComisNew[5,1]
				MsUnlock()
			EndIf
			
			dbSelectArea("SE1")
			dbSetOrder(1)
			
			If dbSeek(xFilial("SE1")+SD2->D2_SERIE+SD2->D2_DOC,.F.)
				While !EOF() .and. SE1->E1_PREFIXO+SE1->E1_NUM == SD2->D2_SERIE+SD2->D2_DOC
					Reclock("SE1",.F.)
					SE1->E1_VEND1 := aComisNew[1,1]
					SE1->E1_VEND2 := aComisNew[2,1]
					SE1->E1_VEND3 := aComisNew[3,1]
					SE1->E1_VEND4 := aComisNew[4,1]
					SE1->E1_VEND5 := aComisNew[5,1]
					
					SE1->E1_COMIS1 := aComisNew[1,2]
					SE1->E1_COMIS2 := aComisNew[2,2]
					SE1->E1_COMIS3 := aComisNew[3,2]
					SE1->E1_COMIS4 := aComisNew[4,2]
					SE1->E1_COMIS5 := aComisNew[5,2]
					MsUnlock()
					
					dbSelectArea("SE1")
					dbSkip()
				EndDo
			EndIf
			dbSelectArea("SD2")
			dbSkip()
		EndDo
	EndIf
	
	IncProc()
Next nz

If cVersao = "11"
  	CloseBrowse()
Else
	oMark:oBrowse:Hide()
EndIf	

Return()